function Est32100_EvolucaoDeCusto_Controller(restEngine, General, ScreenService, Est32100_EvolucaoDeCusto_Service, ProductField, templateManager) {
   
    this.checkUnidadeFields = function(widget) {
        var currentRow = widget.currentRow;

        ProductField.updateProductFilters(widget);
    };

    this.setDefaultValues = function(currentRow, formWidget, first) {
        var data        = moment().format('DD/MM/YYYY');
        // var primeiroDia = moment(data, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
        // var ultimoDia   = moment(data, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');

        currentRow.DTPERINI = data;
        currentRow.DTPERFIN = data;
        if(first) {
            this.getFilialLogada().then(function(success) {
                currentRow.CDFILIAL = success.dataset.filial[0].CDFILIAL;
                currentRow.NMFILIAL = success.dataset.filial[0].NMFILIAL;
                currentRow.DTPERINI = moment().format('DD/MM/YYYY');
                currentRow.DTPERFIN = moment().format('DD/MM/YYYY');
                var widget = templateManager.container.getActiveWidget();
                ProductField.updateProductFilters(widget);
            }.bind(this));
        }
        
        
    };
    
     /* **************************************************
     * Procedimento que checa a validade de algum valor
     * percentual. Possui mensagens padrão para campos
     * específicos.
     *
     * @param Field field
     */
    this.checkAdmittedPercentage = function(field) {
        var value = field.widget.currentRow[field.name];

        //parametrized error messages
        var msgs = {
            VRPERCINVROT: "Percentual deve estar entre 0 e 100%.",
            VRPETOLEENTR: "Percentual deve estar entre 0 e 100%.",
            VRPETOLEINVROT: "Percentual deve estar entre 0 e 100%.",
            DEFAULT: "Valor percentual deve estar entre 0 e 100%."
        };

        //in case of invalid percentage
        if(value !== null && (0 > value || value > 100)) {
            //cleans invalid data
            field.widget.currentRow[field.name] = null;

            //picks error message
            var msg = (msgs[field.name])? msgs[field.name] : msgs.DEFAULT;

            ScreenService.showMessage(msg);
        }
    };

    
	this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
	
    this.setMinMaxDate = function(widget, MaxOrMin){
        if(MaxOrMin === 'MAX') {
            var maxDate = widget.getField('DTPERFIN').value();
            var fieldInicial = widget.getField('DTPERINI');
            fieldInicial.maxDate = maxDate;
        } else {
            var minDate = widget.getField('DTPERINI').value();
            var fieldFinal = widget.getField('DTPERFIN');
            fieldFinal.minDate = minDate;
        }
    };

    this.validateReport = function(widget, format) {
        var currentRow  = widget.currentRow;
        currentRow.__format = format;
        var compproduto = (currentRow.CDPRODFIN)? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

        if (widget.isValid()) {
            if(General.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('GER_CDPICTPROD'))) {
                Est32100_EvolucaoDeCusto_Service.requestReport(currentRow).then(function(birtURL){
                    window.open(birtURL.dataset.URL[0]);
                });
            } else {
                ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
            }
        }
    };

    this.fieldOnChangeRelatorio = function(widget) {
        if(widget.currentRow.REPORT_NAME === 'Est32100EvolCust') {
            widget.getField('PERMINIMO').readOnly           = true;
            widget.getField('PERMINIMO').validations        = {};
            widget.currentRow.PERMINIMO                     = '';
        }
        else if(widget.currentRow.REPORT_NAME === 'Est32101PercentMinimo') {
            widget.getField('PERMINIMO').readOnly          = false;
            widget.getField('PERMINIMO').validations       = {"required": true};

        }
        this.setDefaultValues(widget.currentRow, widget, false);
        widget.reload();
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Est32100_EvolucaoDeCusto_Controller', Est32100_EvolucaoDeCusto_Controller);
});
